VirtualBox

source: vbox/trunk/configure@ 57977

Last change on this file since 57977 was 57939, checked in by vboxsync, 9 years ago

configure: another tweak

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 75.3 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2013 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 haiku)
58 ;;
59 *)
60 echo "Cannot determine OS!"
61 exit 1
62 ;;
63esac
64
65#
66# Defaults
67#
68OSE=1
69ODIR="`pwd`/"
70ODIR_OVERRIDE=0
71OUT_PATH=""
72OUT_PATH_OVERRIDE=0
73SETUP_WINE=
74ONLY_ADDITIONS=0
75TARGET_MACHINE=""
76TARGET_CPU=""
77WITH_XPCOM=1
78WITH_PYTHON=1
79WITH_JAVA=1
80WITH_VMMRAW=1
81WITH_LIBIDL=1
82WITH_GSOAP=0
83WITH_QT4=1
84WITH_SDL=1
85WITH_SDL_TTF=1
86WITH_X11=1
87WITH_ALSA=1
88WITH_PULSE=1
89WITH_DBUS=1
90WITH_DEVMAPPER=1
91WITH_KMODS=1
92WITH_OPENGL=1
93WITH_HARDENING=1
94WITH_UDPTUNNEL=1
95WITH_VDE=0
96WITH_VNC=0
97WITH_EXTPACK=1
98WITH_DOCS=1
99WITH_LIBVPX=1
100BUILD_LIBXML2=
101BUILD_LIBCURL=
102BUILD_LIBSSL=
103BUILD_LIBVPX=
104PASSIVE_MESA=0
105CC="gcc"
106CC32=""
107CC64=""
108CXX="g++"
109CXX32=""
110CXX64=""
111YASM="yasm"
112IASL="iasl"
113XSLTPROC="xsltproc"
114GENISOIMAGE="genisoimage"
115MKISOFS="mkisofs"
116INCCRYPTO=""
117LIBCRYPTO="-lssl -lcrypto"
118LIBPTHREAD="-lpthread"
119LIBCAP="-lcap"
120GSOAP=""
121GSOAP_IMPORT=""
122INCX11="/usr/local/include"
123LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
124LIBXCURSOR="-lXcursor"
125LIBXMU="-lXmu"
126LIBXINERAMA="-lXinerama"
127LIBXRANDR="-lXrandr"
128MAKESELF="makeself"
129MESA="-lGL"
130INCZ=""
131LIBZ="-lz"
132INCVNCSERVER=""
133LIBVNCSERVER="-lvncserver"
134INCDEVMAPPER=""
135LIBDEVMAPPER="-ldevmapper"
136CXX_FLAGS=""
137if [ "$OS" = "freebsd" ]; then
138 INCCURL="-I/usr/local/include"
139 LIBCURL="-L/usr/local/lib -lcurl"
140 INCPULSE="-I/usr/local/include"
141 LIBPULSE="-L/usr/local/lib"
142 INCPNG="-I/usr/local/include"
143 LIBPNG="-L/usr/local/lib -lpng"
144else
145 INCCURL=""
146 LIBCURL="-lcurl"
147 INCPNG=""
148 LIBPNG="-lpng"
149fi
150INCVPX=""
151LIBVPX="-lvpx"
152PKGCONFIG="`which_wrapper pkg-config`"
153PYTHONDIR="/usr /usr/local"
154QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
155QT4DIR_PKGCONFIG=1
156KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
157DEVDIR="`cd \`dirname $0\`; pwd`/tools"
158if [ -d "/lib/modules/`uname -r`/build" ]; then
159 LINUX="/lib/modules/`uname -r`/build"
160elif [ "`echo /lib/modules/*`" != "/lib/modules/*" ]; then
161 # Get the most recent kernel headers if none match the current kernel.
162 for i in /lib/modules/*; do
163 if [ -r "$i/build" ]; then
164 LINUX="$i/build"
165 fi
166 done
167fi
168if [ -z "$LINUX" ]; then
169 LINUX="/usr/src/linux"
170fi
171KCHMVIEWER="kchmviewer"
172LOG="configure.log"
173CNF="AutoConfig.kmk"
174ENV="env.sh"
175BUILD_TYPE="release"
176# the restricting tool is ar (mri mode).
177INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
178
179if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
180 echo "Error: VBox base path contains invalid characters!"
181 exit 1
182fi
183
184# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
185if [ "$OS" = "darwin" ]; then
186 ECHO_N="/bin/echo -n"
187else
188 ECHO_N="echo -n"
189fi
190
191
192cleanup()
193{
194 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
195}
196
197fail()
198{
199 if [ -z "$nofatal" -o "x$1" != "x" ]; then
200 cleanup
201 rm -f $ENV
202 echo "Check $LOG for details"
203 exit 1
204 fi
205}
206
207log()
208{
209 echo "$1"
210 echo "$1" >> $LOG
211}
212
213log_success()
214{
215 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
216 echo "OK."
217 echo "$1" >> $LOG
218 echo >> $LOG
219 echo >> $LOG
220}
221
222log_failure()
223{
224 echo
225 echo " ** $1!"
226 echo "** $1!" >> $LOG
227 echo >> $LOG
228}
229
230cnf_append()
231{
232 printf "%-30s := %s\n" "$1" "$2" >> $CNF
233}
234
235strip_l()
236{
237 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
238}
239
240strip_L()
241{
242 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
243}
244
245strip_I()
246{
247 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
248}
249
250prefix_I()
251{
252 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
253}
254
255check_avail()
256{
257 if [ -z "$1" ]; then
258 log_failure "$2 is empty"
259 fail $3
260 return 1
261 elif which_wrapper $1 > /dev/null; then
262 return 0
263 else
264 log_failure "$1 (variable $2) not found"
265 fail $3
266 return 1
267 fi
268}
269
270
271# Prepare a test
272test_header()
273{
274 echo "***** Checking $1 *****" >> $LOG
275 $ECHO_N "Checking for $1: "
276}
277
278
279# Compile a test
280# $1 compile flags/libs
281# $2 library name
282# $3 package name
283# $4 if this argument is 'nofatal', don't abort
284test_compile()
285{
286 echo "compiling the following source file:" >> $LOG
287 cat $ODIR.tmp_src.cc >> $LOG
288 echo "using the following command line:" >> $LOG
289 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
290 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
291 if [ $? -ne 0 ]; then
292 if [ -z "$4" ]; then
293 echo
294 echo " $2 not found at $1 or $3 headers not found"
295 echo " Check the file $LOG for detailed error information."
296 fail
297 else
298 echo >> $LOG
299 echo >> $LOG
300 fi
301 return 1
302 fi
303 return 0
304}
305
306
307# Execute a compiled test binary
308test_execute()
309{
310 echo "executing the binary" >> $LOG
311 $ODIR.tmp_out > $ODIR.test_execute.log
312 rc=$?
313 cat $ODIR.test_execute.log | tee -a $LOG
314 if [ $rc -ne 0 ]; then
315 fail $1
316 return 1
317 fi
318 echo >> $LOG
319 echo >> $LOG
320 return 0
321}
322
323
324# Execute a compiled test binary
325test_execute_path()
326{
327 ## LD_LIBRARY_PATH to set.
328 local_path="${1}"
329 ## Set this to non-empty to make this test non-fatal.
330 local_nofail="${2}"
331 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
332 LD_LIBRARY_PATH="${local_path}" $ODIR.tmp_out > $ODIR.test_execute.log
333 rc=$?
334 cat $ODIR.test_execute.log | tee -a $LOG
335 if [ $rc -ne 0 ]; then
336 test -z "${local_nofail}" && fail
337 echo >> $LOG
338 echo >> $LOG
339 return 1
340 fi
341 echo >> $LOG
342 echo >> $LOG
343 return 0
344}
345
346
347#
348# Check for OS, MACHINE, CPU
349#
350check_environment()
351{
352 test_header environment
353 BUILD_CPU=`uname -m`
354 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
355 case "$BUILD_CPU" in
356 i[3456789]86|x86|i86pc|BePC)
357 BUILD_MACHINE='x86'
358 LIB='lib'
359 ;;
360 x86_64|amd64)
361 BUILD_MACHINE='amd64'
362 BUILD_CPU='k8'
363 if [ "$OS" != "solaris" ]; then
364 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
365 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
366 LIB='lib64'
367 else
368 # Solaris doesn't seem to subscribe to fhs, libs are usually in
369 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
370 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
371 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
372 # have to make sure the */bin/amd64 dirs are searched before the */bin
373 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
374 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
375 echo "old PATH: $PATH" >> $LOG
376 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
377 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
378 export PATH
379 echo "new PATH: $PATH" >> $LOG
380 LIB='lib/64'
381 fi
382 ;;
383 *)
384 log_failure "Cannot determine system"
385 exit 1
386 ;;
387 esac
388 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
389 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
390 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
391 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
392
393 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
394 echo "export BUILD_PLATFORM" >> $ENV
395 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
396 echo "export BUILD_PLATFORM_ARCH" >> $ENV
397 echo "BUILD_TARGET=\"$OS\"" >> $ENV
398 echo "export BUILD_TARGET" >> $ENV
399 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
400 echo "export BUILD_TARGET_ARCH" >> $ENV
401 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
402 echo "export BUILD_TARGET_CPU" >> $ENV
403 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
404 echo "export BUILD_TYPE" >> $ENV
405}
406
407#
408# Check for gcc with version >= 3.2.
409# We depend on a working gcc, if we fail terminate in every case.
410#
411check_gcc()
412{
413 test_header gcc
414 if check_avail "$CC" CC really; then
415 cc_ver=`$CC -dumpversion` 2>/dev/null
416 if [ $? -ne 0 ]; then
417 log_failure "cannot execute '$CC -dumpversion'"
418 fail really
419 fi
420 if check_avail "$CXX" CXX really; then
421 cxx_ver=`$CXX -dumpversion` 2>/dev/null
422 if [ $? -ne 0 ]; then
423 log_failure "cannot execute '$CXX -dumpversion'"
424 fail really
425 fi
426 cc_maj=`echo $cc_ver|cut -d. -f1`
427 cc_min=`echo $cc_ver|cut -d. -f2`
428 if [ "x$cc_ver" != "x$cxx_ver" ]; then
429 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
430 fail really
431 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
432 log_success "found version $cc_ver"
433 # gcc-4.0 is allowed for Darwin only
434 elif [ $cc_maj -lt 3 \
435 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
436 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
437 -o \( $cc_maj -eq 4 -a $cc_min -gt 9 \) \
438 -o \( $cc_maj -eq 5 -a $cc_min -gt 2 \) \
439 -o $cc_maj -gt 5 ]; then
440 log_failure "gcc version $cc_maj.$cc_min found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<10 or gcc 5.2"
441 fail really
442 else
443 log_success "found version $cc_ver"
444 fi
445 if [ "$BUILD_MACHINE" = "amd64" ]; then
446 [ -z "$CC32" ] && CC32="$CC -m32"
447 [ -z "$CXX32" ] && CXX32="$CXX -m32"
448 else
449 [ -z "$CC32" ] && CC32="$CC"
450 [ -z "$CXX32" ] && CXX32="$CXX"
451 fi
452 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
453 [ -z "$CC64" ] && CC64="$CC -m64"
454 [ -z "$CXX64" ] && CXX64="$CXX -m64"
455 fi
456 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
457 CC32="undefined"
458 CXX32="undefined"
459 fi
460 if [ "$CC" != "gcc" ]; then
461 cnf_append "TOOL_GCC3_CC" "$CC"
462 cnf_append "TOOL_GCC3_AS" "$CC"
463 cnf_append "TOOL_GCC3_LD" "$CC"
464 cnf_append "TOOL_GXX3_CC" "$CC"
465 cnf_append "TOOL_GXX3_AS" "$CC"
466 fi
467 if [ "$CXX" != "g++" ]; then
468 cnf_append "TOOL_GCC3_CXX" "$CXX"
469 cnf_append "TOOL_GXX3_CXX" "$CXX"
470 cnf_append "TOOL_GXX3_LD" "$CXX"
471 fi
472 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
473 cnf_append "TOOL_GCC32_CC" "$CC32"
474 cnf_append "TOOL_GCC32_AS" "$CC32"
475 cnf_append "TOOL_GCC32_LD" "$CC32"
476 cnf_append "TOOL_GXX32_CC" "$CC32"
477 cnf_append "TOOL_GXX32_AS" "$CC32"
478 fi
479 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
480 cnf_append "TOOL_GCC32_CXX" "$CXX32"
481 cnf_append "TOOL_GXX32_CXX" "$CXX32"
482 cnf_append "TOOL_GXX32_LD" "$CXX32"
483 fi
484 # this isn't not necessary, there is not such tool.
485 if [ -n "$CC64" ]; then
486 cnf_append "TOOL_GCC64_CC" "$CC64"
487 cnf_append "TOOL_GCC64_AS" "$CC64"
488 cnf_append "TOOL_GCC64_LD" "$CC64"
489 cnf_append "TOOL_GXX64_CC" "$CC64"
490 cnf_append "TOOL_GXX64_AS" "$CC64"
491 fi
492 if [ -n "$CXX64" ]; then
493 cnf_append "TOOL_GCC64_CXX" "$CXX64"
494 cnf_append "TOOL_GXX64_CXX" "$CXX64"
495 cnf_append "TOOL_GXX64_LD" "$CXX64"
496 fi
497 # Solaris sports a 32-bit gcc/g++.
498 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
499 [ "$CC" = "gcc" ] && CC="gcc -m64"
500 [ "$CXX" = "g++" ] && CXX="g++ -m64"
501 fi
502 fi
503 fi
504}
505
506
507#
508# Check for the OpenWatcom compiler, needed for compiling the BIOS
509#
510# If the system has Open Watcom installed, WATCOM will be set in the
511# environment. If the user has her/his own Open Watcom install it will be
512# pointed to by on the command line, which will set the WATCOM variable.
513# The only exception is detecting OpenWatcom in tools/common/openwatcom.
514#
515check_open_watcom()
516{
517 test_header "Open Watcom"
518
519 if [ -z "$WATCOM" ]; then
520 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
521 if [ -z "$WATCOM" ]; then
522 log_failure "Open Watcom was not found"
523 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
524 return 0;
525 fi
526 fi
527
528 case "$OS" in
529 "darwin") wc_bin="binosx";; # ??
530 "dos") wc_bin="binw";;
531 "freebsd") wc_bin="binfbsd";; # ??
532 "linux") wc_bin="binl";;
533 "solaris") wc_bin="binsol";; # ??
534 "os2") wc_bin="binp";;
535 "win") wc_bin="binnt";;
536 *) wc_bin="binl";;
537 esac
538
539 # Check that the tools we use are there.
540 for prog in wasm wcc wlink;
541 do
542 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
543 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
544 fail
545 fi
546 done
547
548 # Use WASM to get the version.
549 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
550 if [ -z "$wasm_ver" ]; then
551 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
552 fail
553 fi
554 log_success "found version $wasm_ver"
555 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
556 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
557
558 unset wasm_ver
559 unset wc_wasm
560 unset wc_bin
561}
562
563
564#
565# Check for yasm, needed to compile assembler files
566#
567check_yasm()
568{
569 test_header yasm
570 if check_avail "$YASM" YASM; then
571 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
572 if [ $? -ne 0 ]; then
573 log_failure "yasm not found"
574 fail
575 else
576 yasm_maj=`echo $yasm_ver|cut -d. -f1`
577 yasm_min=`echo $yasm_ver|cut -d. -f2`
578 yasm_rev=`echo $yasm_ver|cut -d. -f3`
579 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
580 if [ $yasm_ver_mul -lt 501 ]; then
581 log_failure "found version $yasm_ver, expected at least 0.5.1"
582 fail
583 else
584 log_success "found version $yasm_ver"
585 fi
586 fi
587 fi
588}
589
590
591#
592# Check for the iasl ACPI compiler, needed to compile vbox.dsl
593#
594check_iasl()
595{
596 test_header iasl
597 if check_avail "$IASL" IASL; then
598 iasl_ver=`$IASL|grep "ASL.*version"|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
599 if [ $? -ne 0 ]; then
600 log_failure "iasl not found"
601 fail
602 else
603 log_success "found version $iasl_ver"
604 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
605 fi
606 fi
607}
608
609
610#
611# Check for xsltproc, needed by Main
612#
613check_xsltproc()
614{
615 if [ -n "$BUILD_LIBXSLT" ]; then
616 return 0;
617 fi
618 test_header xslt
619 if check_avail "$XSLTPROC" XSLTPROC; then
620 xsltproc_ver=`$XSLTPROC --version`
621 if [ $? -ne 0 ]; then
622 log_failure "xsltproc not found"
623 fail
624 else
625 log_success "found"
626 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
627 fi
628 fi
629}
630
631
632#
633# Check for mkisofs, needed to build the CDROM image containing the additions
634#
635check_mkisofs()
636{
637 test_header mkisofs
638 if which_wrapper $GENISOIMAGE > /dev/null; then
639 mkisofs_ver=`$GENISOIMAGE --version`
640 if [ $? -ne 0 ]; then
641 log_failure "mkisofs not found"
642 fail
643 else
644 log_success "found $mkisofs_ver"
645 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
646 fi
647 elif check_avail "$MKISOFS" MKISOFS; then
648 mkisofs_ver=`$MKISOFS --version`
649 if [ $? -ne 0 ]; then
650 log_failure "mkisofs not working"
651 fail
652 else
653 log_success "found $mkisofs_ver"
654 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
655 fi
656 fi
657}
658
659
660#
661# Check for libxml2, needed by VBoxSettings and Runtime.
662# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
663#
664check_libxml2()
665{
666 if [ -z "$BUILD_LIBXML2" ]; then
667 test_header libxml2
668 if which_wrapper pkg-config > /dev/null; then
669 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
670 if [ $? -ne 0 ]; then
671 log_failure "libxml2 not found"
672 fail
673 else
674 FLGXML2=`pkg-config libxml-2.0 --cflags`
675 INCXML2=`strip_I "$FLGXML2"`
676 LIBXML2=`pkg-config libxml-2.0 --libs`
677 cat > $ODIR.tmp_src.cc << EOF
678#include <cstdio>
679#include <libxml/xmlversion.h>
680extern "C" int main(void)
681{
682 printf("found version %s", LIBXML_DOTTED_VERSION);
683#if LIBXML_VERSION >= 20626
684 printf(", OK.\n");
685 return 0;
686#else
687 printf(", expected version 2.6.26 or higher\n");
688 return 1;
689#endif
690}
691EOF
692 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
693 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
694 if test_execute; then
695 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
696 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
697 fi
698 fi
699 fi
700 elif which_wrapper xml2-config; then
701 libxml2_ver=`xml2-config --version`
702 if [ $? -ne 0 ]; then
703 log_failure "xml2-config not found"
704 fail
705 else
706 log_success "found version $libxml2_ver"
707 FLGXML2=`xml2-config --cflags`
708 INCXML2=`strip_I "$FLGXML2"`
709 LIBXML2=`xml2-config --libs`
710 cat > $ODIR.tmp_src.cc << EOF
711#include <cstdio>
712#include <libxml/xmlversion.h>
713extern "C" int main(void)
714{
715 printf("found version %s", LIBXML_DOTTED_VERSION);
716#if LIBXML_VERSION >= 20626
717 printf(", OK.\n");
718 return 0;
719#else
720 printf(", expected version 2.6.26 or higher\n");
721 return 1;
722#endif
723}
724EOF
725 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
726 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
727 if test_execute; then
728 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
729 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
730 fi
731 fi
732 fi
733 else
734 log_failure "neither pkg-config nor xml2-config found"
735 fail
736 fi
737 fi
738}
739
740
741#
742# Check for libIDL, needed by xpcom
743#
744check_libidl()
745{
746 test_header libIDL
747
748 if which_wrapper libIDL-config-2 > /dev/null; then
749 libidl_ver=`libIDL-config-2 --version`
750 if [ $? -ne 0 ]; then
751 log_failure "libIDL-config-2 not working"
752 fail
753 else
754 log_success "found version $libidl_ver"
755 cnf_append "VBOX_LIBIDL_CONFIG" \
756 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
757 fi
758 elif check_avail "libIDL-config" libIDL-config; then
759 libidl_ver=`libIDL-config --version`
760 if [ $? -ne 0 ]; then
761 log_failure "libIDL-config not working"
762 fail
763 else
764 log_success "found version $libidl_ver"
765 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
766 fi
767 fi
768}
769
770
771#
772# Check for libdevmapper, needed by the VBoxVolInfo
773#
774check_libdevmapper()
775{
776 test_header libdevmapper
777 cat > $ODIR.tmp_src.cc << EOF
778#include <cstdio>
779extern "C" {
780#define private
781#include <libdevmapper.h>
782int main()
783{
784 char version[80];
785
786 if (!dm_get_library_version(version, sizeof(version)))
787 {
788 printf("dm_get_library_version() failed.\n");
789 return 1;
790 }
791
792 const char* v=version;
793 unsigned int major = 0, minor = 0, micro = 0;
794
795 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
796 if (*v == '.') v++;
797 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
798 if (*v == '.') v++;
799 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
800
801 printf("found version %s", version);
802 if (major*10000 + minor*100 + micro >= 10200)
803 {
804 printf(", OK.\n");
805 return 0;
806 }
807 else
808 {
809 printf(", expected version 1.02 or higher\n");
810 return 1;
811 }
812}
813}
814EOF
815 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
816 if test_execute; then
817 cnf_append "VBOX_WITH_DEVMAPPER" "1"
818 fi
819 fi
820}
821
822
823#
824# Check for openssl, needed for RDP and S3
825#
826check_ssl()
827{
828 if [ -z "$BUILD_LIBSSL" ]; then
829 test_header ssl
830 cat > $ODIR.tmp_src.cc << EOF
831#include <cstdio>
832#include <openssl/opensslv.h>
833#include <openssl/ssl.h>
834extern "C" int main(void)
835{
836 printf("found version %s", OPENSSL_VERSION_TEXT);
837 SSL_library_init();
838#if OPENSSL_VERSION_NUMBER >= 0x00908000
839 printf(", OK.\n");
840 return 0;
841#else
842 printf(", expected version 0.9.8 or higher\n");
843 return 1;
844#endif
845}
846EOF
847 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
848 if test_execute nofatal; then
849 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
850 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
851 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
852 fi
853 fi
854 fi
855}
856
857
858#
859# Check for pthread, needed by VBoxSVC, frontends, ...
860#
861check_pthread()
862{
863 test_header pthread
864 cat > $ODIR.tmp_src.cc << EOF
865#include <cstdio>
866#include <pthread.h>
867extern "C" int main(void)
868{
869 pthread_mutex_t mutex;
870 if (pthread_mutex_init(&mutex, NULL)) {
871 printf("pthread_mutex_init() failed\n");
872 return 1;
873 }
874 if (pthread_mutex_lock(&mutex)) {
875 printf("pthread_mutex_lock() failed\n");
876 return 1;
877 }
878 if (pthread_mutex_unlock(&mutex)) {
879 printf("pthread_mutex_unlock() failed\n");
880 return 1;
881 }
882 printf("found, OK.\n");
883}
884EOF
885 if test_compile $LIBPTHREAD pthread pthread; then
886 if test_execute; then
887 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
888 fi
889 fi
890}
891
892
893#
894# Check for zlib, needed by VBoxSVC, Runtime, ...
895#
896check_z()
897{
898 test_header zlib
899 cat > $ODIR.tmp_src.cc << EOF
900#include <cstdio>
901#include <zlib.h>
902extern "C" int main(void)
903{
904 printf("found version %s", ZLIB_VERSION);
905#if ZLIB_VERNUM >= 0x1210
906 printf(", OK.\n");
907 return 0;
908#else
909 printf(", expected version 1.2.1 or higher\n");
910 return 1;
911#endif
912}
913EOF
914 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
915 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
916 if test_execute; then
917 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux)" >> $CNF
918 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
919 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
920 echo "endif" >> $CNF
921 fi
922 fi
923}
924
925
926#
927# Check for libpng, needed by kchmviewer
928#
929check_png()
930{
931 test_header libpng
932 cat > $ODIR.tmp_src.cc << EOF
933#include <cstdio>
934#include <png.h>
935extern "C" int main(void)
936{
937 printf("found version %s", PNG_LIBPNG_VER_STRING);
938#if PNG_LIBPNG_VER >= 10205
939 printf(", OK.\n");
940 return 0;
941#else
942 printf(", expected version 1.2.5 or higher\n");
943 return 1;
944#endif
945}
946EOF
947 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
948 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
949 if test_execute; then
950 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
951 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
952 fi
953 fi
954}
955
956#
957# Check for libvncserver, needed for VNC in OSE
958#
959check_vncserver()
960{
961 test_header libvncserver
962 cat > $ODIR.tmp_src.cc <<EOF
963#include <cstdio>
964#include <rfb/rfbconfig.h>
965
966extern "C" int main()
967{
968 const char* v=LIBVNCSERVER_VERSION;
969 unsigned int major = 0, minor = 0, micro = 0;
970
971 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
972 if (*v == '.') v++;
973 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
974 if (*v == '.') v++;
975 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
976
977 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
978 if (major*10000 + minor*100 + micro >= 900)
979 {
980 printf(", OK.\n");
981 return 0;
982 }
983 else
984 {
985 printf(", expected version 0.9 or higher\n");
986 return 1;
987 }
988}
989EOF
990 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
991 if test_execute; then
992 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
993 fi
994 fi
995}
996
997#
998# Check for libcurl, needed by S3
999#
1000check_curl()
1001{
1002 if [ -z "$BUILD_LIBCURL" ]; then
1003 test_header libcurl
1004 cat > $ODIR.tmp_src.cc << EOF
1005#include <cstdio>
1006#include <curl/curl.h>
1007extern "C" int main(void)
1008{
1009 printf("found version %s", LIBCURL_VERSION);
1010#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
1011 printf(", OK.\n");
1012 return 0;
1013#else
1014 printf(", expected version 7.19.1 or higher\n");
1015 return 1;
1016#endif
1017}
1018EOF
1019 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1020 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1021 if test_execute; then
1022 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1023 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1024 fi
1025 fi
1026 fi
1027}
1028
1029
1030#
1031# Check for pam, needed by VRDPAuth
1032# Version 79 was introduced in 9/2005, do we support older versions?
1033# Debian/sarge uses 76
1034# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1035#
1036check_pam()
1037{
1038 test_header pam
1039 cat > $ODIR.tmp_src.cc << EOF
1040#include <cstdio>
1041#include <security/pam_appl.h>
1042extern "C" int main(void)
1043{
1044 printf("found version %d", __LIBPAM_VERSION);
1045 if (__LIBPAM_VERSION >= 76)
1046 {
1047 printf(", OK.\n");
1048 return 0;
1049 }
1050 else
1051 {
1052 printf(", expected version 76 or higher\n");
1053 return 1;
1054 }
1055}
1056EOF
1057 if test_compile "-lpam" pam pam nofatal; then
1058 if test_execute nofatal; then
1059 return 0;
1060 fi
1061 fi
1062 echo "pam0.x not found"
1063 test_header linux_pam
1064 cat > $ODIR.tmp_src.cc << EOF
1065#include <cstdio>
1066#include <security/pam_appl.h>
1067extern "C" int main(void)
1068{
1069 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1070 if (__LINUX_PAM__ >= 1)
1071 {
1072 printf(", OK.\n");
1073 return 0;
1074 }
1075 else
1076 {
1077 printf(", expected version 1.0 or higher\n");
1078 return 1;
1079 }
1080}
1081EOF
1082 if test_compile "-lpam" pam pam; then
1083 test_execute
1084 fi
1085}
1086
1087
1088#
1089# Check for the SDL library, needed by VBoxSDL and VirtualBox
1090# We depend at least on version 1.2.7
1091#
1092check_sdl()
1093{
1094 test_header SDL
1095 if [ "$OS" = "darwin" ]; then
1096 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1097 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1098 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1099 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1100 fi
1101 if [ -n "$PATH_SDK_LIBSDL" ]; then
1102 foundsdl=1
1103 INCSDL="$PATH_SDK_LIBSDL/Headers"
1104 FLDSDL="-framework SDL"
1105 else
1106 log_failure "SDL framework not found"
1107 fail
1108 fi
1109 else
1110 if which_wrapper sdl-config > /dev/null; then
1111 FLGSDL=`sdl-config --cflags`
1112 INCSDL=`strip_I "$FLGSDL"`
1113 LIBSDL=`sdl-config --libs`
1114 LIBSDLMAIN="-lSDLmain"
1115 FLDSDL=
1116 foundsdl=1
1117 fi
1118 fi
1119 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1120 if [ -n "$foundsdl" ]; then
1121 cat > $ODIR.tmp_src.cc << EOF
1122#include <cstdio>
1123#include <SDL.h>
1124#include <SDL_main.h>
1125#undef main
1126extern "C" int main(int argc, char** argv)
1127{
1128 printf("found version %d.%d.%d",
1129 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1130#if SDL_VERSION_ATLEAST(1,2,7)
1131 printf(", OK.\n");
1132 return 0;
1133#else
1134 printf(", expected version 1.2.7 or higher\n");
1135 return 1;
1136#endif
1137}
1138EOF
1139 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1140 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1141 if test_execute; then
1142 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1143 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1144 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1145 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1146 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1147 fi
1148 fi
1149 else
1150 log_failure "SDL not found (can be disabled using --disable-sdl)"
1151 fail
1152 fi
1153}
1154
1155
1156#
1157# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1158#
1159check_sdl_ttf()
1160{
1161 test_header SDL_ttf
1162 cat > $ODIR.tmp_src.cc << EOF
1163#include <cstdio>
1164#include <SDL_ttf.h>
1165#ifndef SDL_TTF_MAJOR_VERSION
1166#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1167#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1168#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1169#endif
1170extern "C" int main(void)
1171{
1172 printf("found version %d.%d.%d",
1173 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1174#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1175 printf(", OK.\n");
1176 return 0;
1177#else
1178 printf(", expected version 2.0.6 or higher\n");
1179 return 1;
1180#endif
1181}
1182EOF
1183 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1184 if ! test_execute nofatal; then
1185 cnf_append "VBOX_WITH_SECURELABEL" ""
1186 fi
1187 else
1188 echo "not found -- disabling VBoxSDL secure label."
1189 cnf_append "VBOX_WITH_SECURELABEL" ""
1190 fi
1191}
1192
1193
1194#
1195# Check for libasound, needed by the ALSA audio backend
1196#
1197check_alsa()
1198{
1199 test_header ALSA
1200 cat > $ODIR.tmp_src.cc << EOF
1201#include <cstdio>
1202#include <alsa/asoundlib.h>
1203extern "C" int main(void)
1204{
1205 printf("found version %d.%d.%d",
1206 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1207#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1208 printf(", OK.\n");
1209 return 0;
1210#else
1211 printf(", expected version 1.0.6 or higher\n");
1212 return 1;
1213#endif
1214}
1215EOF
1216 if test_compile "-lasound" asound asound; then
1217 test_execute
1218 fi
1219}
1220
1221
1222#
1223# Check for PulseAudio
1224#
1225check_pulse()
1226{
1227 test_header "PulseAudio"
1228 cat > $ODIR.tmp_src.cc << EOF
1229#include <cstdio>
1230#include <pulse/version.h>
1231extern "C" int main(void)
1232{
1233 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1234#if PA_API_VERSION >= 9
1235 printf(", OK.\n");
1236 return 0;
1237#else
1238 printf(", expected version 0.9.0 (API version 9) or higher\n");
1239 return 1;
1240#endif
1241}
1242EOF
1243 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1244 test_execute
1245 fi
1246}
1247
1248
1249#
1250# Check for the X libraries (Xext, X11)
1251#
1252check_x()
1253{
1254 test_header "X libraries"
1255 cat > $ODIR.tmp_src.cc << EOF
1256#include <cstdio>
1257#include <X11/Xlib.h>
1258extern "C" int main(void)
1259{
1260 Display *dpy;
1261 int scrn_num;
1262 Screen *scrn;
1263 Window win;
1264
1265 dpy = XOpenDisplay(NULL);
1266 scrn_num = DefaultScreen(dpy);
1267 scrn = ScreenOfDisplay(dpy, scrn_num);
1268 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1269 0, 16, InputOutput, CopyFromParent, 0, NULL);
1270 XDestroyWindow(dpy, win);
1271 XCloseDisplay(dpy);
1272}
1273EOF
1274 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1275 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1276 log_success "found"
1277 fi
1278}
1279
1280
1281#
1282# Check for the Xcursor library, needed by VBoxSDL.
1283#
1284check_xcursor()
1285{
1286 test_header Xcursor
1287 cat > $ODIR.tmp_src.cc << EOF
1288#include <cstdio>
1289#include <X11/Xlib.h>
1290#include <X11/Xcursor/Xcursor.h>
1291extern "C" int main(void)
1292{
1293 XcursorImage *cursor = XcursorImageCreate (10, 10);
1294 XcursorImageDestroy(cursor);
1295 return 0;
1296}
1297EOF
1298 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1299 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1300 log_success "found"
1301 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1302 fi
1303}
1304
1305
1306#
1307# Check for the Xinerama library, needed by the Qt GUI
1308#
1309check_xinerama()
1310{
1311 test_header Xinerama
1312 cat > $ODIR.tmp_src.cc << EOF
1313#include <X11/Xlib.h>
1314#include <X11/extensions/Xinerama.h>
1315extern "C" int main(void)
1316{
1317 Display *dpy;
1318 Bool flag;
1319 dpy = XOpenDisplay(NULL);
1320 if (dpy)
1321 {
1322 flag = XineramaIsActive(dpy);
1323 XCloseDisplay(dpy);
1324 }
1325}
1326EOF
1327 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1328 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1329 log_success "found"
1330 fi
1331}
1332
1333
1334#
1335# Check for the Xinerama library, needed by the Qt GUI
1336#
1337check_xrandr()
1338{
1339 test_header Xrandr
1340 cat > $ODIR.tmp_src.cc << EOF
1341#include <X11/Xlib.h>
1342#include <X11/extensions/Xrandr.h>
1343extern "C" int main(void)
1344{
1345 Display *dpy;
1346 Bool flag;
1347 int major, minor;
1348 dpy = XOpenDisplay(NULL);
1349 if (dpy)
1350 {
1351 flag = XRRQueryVersion(dpy, &major, &minor);
1352 XCloseDisplay(dpy);
1353 }
1354}
1355EOF
1356 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1357 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1358 log_success "found"
1359 fi
1360}
1361
1362
1363#
1364# Check for OpenGL
1365#
1366check_opengl()
1367{
1368 # On darwin this is a on/off decision only
1369 if [ "$OS" = "darwin" ]; then
1370 test_header "OpenGL support"
1371 echo "enabled"
1372 cnf_append "VBOX_WITH_CROGL" "1"
1373 else
1374 check_xmu
1375 check_mesa
1376 fi
1377}
1378
1379
1380#
1381# Check for the Xmu library, needed by OpenGL
1382#
1383check_xmu()
1384{
1385 test_header Xmu
1386 cat > $ODIR.tmp_src.cc << EOF
1387#include <cstdio>
1388#include <X11/Xatom.h>
1389#include <X11/Xlib.h>
1390#include <X11/Xutil.h>
1391#include <X11/Xmu/StdCmap.h>
1392extern "C" int main(void)
1393{
1394 Display *dpy;
1395 int scrn_num;
1396 Screen *scrn;
1397
1398 dpy = XOpenDisplay(NULL);
1399 if (dpy)
1400 {
1401 scrn_num = DefaultScreen(dpy);
1402 scrn = ScreenOfDisplay(dpy, scrn_num);
1403 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1404 24, XA_RGB_DEFAULT_MAP, False, True);
1405 printf("Status = %x\n", status);
1406 XCloseDisplay(dpy);
1407 }
1408 return 0;
1409}
1410EOF
1411 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1412 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1413 log_success "found"
1414 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1415 fi
1416}
1417
1418#
1419# Check for Mesa, needed by OpenGL
1420#
1421check_mesa()
1422{
1423 test_header "Mesa / GLU"
1424 cat > $ODIR.tmp_src.cc << EOF
1425#include <cstdio>
1426#include <X11/Xlib.h>
1427#include <GL/glx.h>
1428#include <GL/glu.h>
1429extern "C" int main(void)
1430{
1431 Display *dpy;
1432 int major, minor;
1433
1434 dpy = XOpenDisplay(NULL);
1435 if (dpy)
1436 {
1437 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1438 XCloseDisplay(dpy);
1439 if (glx_version)
1440 {
1441 printf("found version %u.%u, OK.\n", major, minor);
1442 return 0;
1443 }
1444 }
1445 printf("found (inactive), OK.\n");
1446 return 0;
1447}
1448EOF
1449 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1450 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1451 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1452 test_execute
1453 fi
1454}
1455
1456
1457#
1458# Check for the Qt4 library, needed by the VirtualBox frontend
1459#
1460# Currently not fatal.
1461#
1462check_qt4()
1463{
1464 foundqt4=
1465 test_header Qt4
1466 cat > $ODIR.tmp_src.cc << EOF
1467#include <QtGlobal>
1468extern "C" int main(void)
1469{
1470#if QT_VERSION >= 0x040800
1471 return 0;
1472#else
1473 return 1;
1474#endif
1475}
1476EOF
1477 if [ "$OS" = "darwin" ]; then
1478 # First check if there is the internal version of Qt. If yes nothing else
1479 # has to be done.
1480 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1481 for t in $QT_INTERNAL; do
1482 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1483 cnf_append "VBOX_WITH_QT4_SUN" "1"
1484 log_success "use internal version"
1485 return
1486 fi
1487 done
1488 # Now try the user provided directory and some of the standard directories.
1489 QT_TRIES="$QT4DIR /System/Library /Library"
1490 for t in $QT_TRIES; do
1491 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1492 PATH_SDK_QT4="$t"
1493 break
1494 fi
1495 done
1496 # Add the necessary params for building the test application
1497 if [ -n "$PATH_SDK_QT4" ]; then
1498 foundqt4=1
1499 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1500 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1501 FLGQT4="-framework QtCore"
1502 else
1503 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1504 fail
1505 fi
1506 else # !darwin
1507 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1508 # default is to use pkg-config
1509 if which_wrapper pkg-config > /dev/null; then
1510 qt4_ver=`pkg-config QtCore --modversion 2>> $LOG`
1511 if [ $? -eq 0 ]; then
1512 FLGQT4=`pkg-config QtCore --cflags`
1513 INCQT4=`strip_I "$FLGQT4"`
1514 LIBQT4=`PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 pkg-config QtCore --libs`
1515 TOOLQT4=`pkg-config QtCore --variable=prefix`
1516 TOOLQT4MOC="`pkg-config QtCore --variable=moc_location`"
1517 TOOLQT4BIN="`dirname $TOOLQT4MOC`"
1518 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1519 test_execute_path "`strip_L "$LIBQT4"`" nofatal && foundqt4=3 # pkg-config
1520 fi
1521 fi
1522 else
1523 log_failure "pkg-config not found"
1524 fail
1525 fi
1526 fi
1527 if [ -z "$foundqt4" ]; then
1528 # do it the old way (e.g. user has specified QT4DIR)
1529 for q in $QT4DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v4.8.*; do
1530 INCQT4="$q/include $q/include/QtCore"
1531 FLGQT4="-DQT_SHARED"
1532 I_INCQT4=`prefix_I "$INCQT4"`
1533 LIBQT4="-L$q/lib -lQtCoreVBox"
1534 TOOLQT4="$q"
1535 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal &&
1536 test_execute_path "`strip_L "$LIBQT4"`" nofatal; then
1537 foundqt4=2 # internal
1538 break;
1539 fi
1540 LIBQT4="-L$q/lib -lQtCore"
1541 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal &&
1542 test_execute_path "`strip_L "$LIBQT4"`" nofatal; then
1543 foundqt4=1 # no pkg-config, Qt directory
1544 break;
1545 fi
1546 done
1547 fi
1548 fi
1549 if [ -n "$foundqt4" ]; then
1550 # we decided which version of Qt to use. Now enforce the version requirement
1551 cat > $ODIR.tmp_src.cc << EOF
1552#include <cstdio>
1553#include <QtGlobal>
1554extern "C" int main(void)
1555{
1556 printf("found version %s", QT_VERSION_STR);
1557#if QT_VERSION >= 0x040800
1558 printf(", OK.\n");
1559 return 0;
1560#else
1561 printf(", expected version 4.8.0 or higher\n");
1562 return 1;
1563#endif
1564}
1565EOF
1566 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1567 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1568 if test_execute_path "`strip_L "$LIBQT4"`"; then
1569 if [ "$OS" = "darwin" ]; then
1570 # Successful build & run the test application so add the necessary
1571 # params to AutoConfig.kmk
1572 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1573 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1574 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1575 # Check for the moc tool in the Qt directory found & some standard
1576 # directories.
1577 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1578 if which_wrapper "$q/bin/moc" > /dev/null; then
1579 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1580 fi
1581 done
1582 else
1583 # strip .../QtCore as we add components ourself
1584 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1585 # store only the first path, remove all other pathes
1586 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1587 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1588 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1589 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1590 # this is not quite right since the qt libpath does not have to be first...
1591 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1592 if [ "$foundqt4" = "2" ]; then
1593 cnf_append "VBOX_WITH_QT4_SUN" "1"
1594 elif [ "$foundqt4" = "3" ]; then
1595 cnf_append "VBOX_PATH_QT4" "$TOOLQT4"
1596 cnf_append "PATH_SDK_QT4" "$TOOLQT4"
1597 cnf_append "PATH_TOOL_QT4_BIN" "$TOOLQT4BIN"
1598 return
1599 fi
1600 test_header "Qt4 devtools"
1601 # try it with a suffix, some platforms use that
1602 if which_wrapper "$TOOLQT4/bin/moc-qt4" > /dev/null; then
1603 QT4BINSUFF="-qt4"
1604 else
1605 QT4BINSUFF=""
1606 fi
1607 moc_ver=`$TOOLQT4/bin/moc$QT4BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1608 if [ $? -ne 0 ]; then
1609 log_failure "moc$QT4BINSUFF not working"
1610 fail
1611 else
1612 log_success "found version $moc_ver"
1613 cnf_append "VBOX_PATH_QT4" "$TOOLQT4"
1614 cnf_append "PATH_SDK_QT4" "$TOOLQT4"
1615 cnf_append "PATH_TOOL_QT4_BIN" "$TOOLQT4/bin"
1616 [ -n "$QT4BINSUFF" ] && cnf_append "TOOL_QT4_BIN_SUFF" "$QT4BINSUFF"
1617 fi
1618 fi
1619 fi
1620 else
1621 log_failure "qt4 not working"
1622 fail
1623 fi
1624 else
1625 log_failure "qt4 not found"
1626 fail
1627 fi
1628}
1629
1630
1631#
1632# Check for libvpx
1633#
1634check_vpx()
1635{
1636 if [ -z "$BUILD_LIBVPX" ]; then
1637 test_header libvpx
1638 if which_wrapper pkg-config > /dev/null; then
1639 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1640 if [ $? -eq 0 ]; then
1641 FLGVPX=`pkg-config vpx --cflags`
1642 INCVPX=`strip_I "$FLGVPX"`
1643 LIBVPX=`pkg-config vpx --libs`
1644 fi
1645 cat > $ODIR.tmp_src.cc << EOF
1646#include <cstdio>
1647#include <vpx/vpx_codec.h>
1648extern "C" int main(void)
1649{
1650 int version = vpx_codec_version();
1651 int verMajor = VPX_VERSION_MAJOR(version);
1652 int verMinor = VPX_VERSION_MINOR(version);
1653 int verPatch = VPX_VERSION_PATCH(version);
1654 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1655 if ( verMajor == 1 && verMinor >= 0
1656 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1657 {
1658 printf(", OK.\n");
1659 return 0;
1660 }
1661 else
1662 {
1663 printf(", expected version 0.9.5 or higher\n");
1664 return 1;
1665 }
1666}
1667EOF
1668 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1669 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1670 if test_execute; then
1671 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1672 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1673 fi
1674 fi
1675 fi
1676 fi
1677}
1678
1679
1680#
1681# Check whether static libstdc++ is installed. This library is required
1682# for the Linux guest additions.
1683#
1684check_staticlibstdcxx()
1685{
1686 test_header "static stc++ library"
1687 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1688 cat > $ODIR.tmp_src.cc << EOF
1689#include <string>
1690
1691extern "C" int main(void)
1692{
1693 std::string s = "test";
1694 return 0;
1695}
1696EOF
1697 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1698 log_success "found"
1699 fi
1700}
1701
1702
1703#
1704# Check for Linux sources
1705#
1706check_linux()
1707{
1708 test_header "Linux kernel sources"
1709 cat > $ODIR.tmp_src.c << EOF
1710#include <linux/version.h>
1711int printf(const char *format, ...);
1712int main(void)
1713{
1714 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1715 (LINUX_VERSION_CODE % 65536) / 256,
1716 LINUX_VERSION_CODE % 256);
1717#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1718 printf(", OK.\n");
1719 return 0;
1720#else
1721 printf(", expected version 2.4.0 or higher\n");
1722 return 1;
1723#endif
1724}
1725EOF
1726 echo "compiling the following source file:" >> $LOG
1727 cat $ODIR.tmp_src.c >> $LOG
1728 echo "using the following command line:" >> $LOG
1729 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1730 "-I$LINUX/include/generated/uapi" >> $LOG
1731 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1732 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1733 if [ $? -ne 0 ]; then
1734 echo
1735 echo " Linux kernel headers not found at $LINUX"
1736 echo " Check the file $LOG for detailed error information."
1737 fail
1738 else
1739 if test_execute; then
1740 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1741 fi
1742 fi
1743}
1744
1745
1746#
1747# Check for kchmviewer, needed to display the online help
1748# (unused as we ship kchmviewer)
1749#
1750check_kchmviewer()
1751{
1752 test_header kchmviewer
1753 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1754 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1755 if [ $? -ne 0 ]; then
1756 log_failure "kchmviewer not working"
1757 fail
1758 else
1759 log_success "found version $kchmviewer_ver"
1760 fi
1761 fi
1762}
1763
1764
1765#
1766# Check for the kBuild tools, we don't support GNU make
1767#
1768check_kbuild()
1769{
1770 test_header kBuild
1771 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1772 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1773 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1774 echo "export PATH_KBUILD" >> $ENV
1775 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1776 echo "export PATH_DEVTOOLS" >> $ENV
1777 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1778 echo "export PATH_KBUILD_BIN" >> $ENV
1779 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1780 if [ "$OS" = "solaris" ]; then
1781 # Because of sh being non-default shell in Solaris we need to export PATH again when
1782 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1783 echo "PATH=\"$ORGPATH\"" >> $ENV
1784 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1785 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1786 else
1787 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1788 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1789 fi
1790 echo "export PATH" >> $ENV
1791 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1792 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1793 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1794 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1795 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1796 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1797 echo "export PATH_KBUILD" >> $ENV
1798 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1799 echo "export PATH_DEVTOOLS" >> $ENV
1800 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1801 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1802 echo "export PATH_KBUILD_BIN" >> $ENV
1803 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1804 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1805 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1806 echo "export PATH" >> $ENV
1807 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1808 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1809 elif check_avail "kmk" KBUILDDIR really; then
1810 # check for installed kBuild
1811 KBUILD_SED="`which_wrapper kmk_sed`"
1812 else
1813 fail
1814 fi
1815 log_success "found"
1816}
1817
1818
1819#
1820# Check for compiler.h
1821# Some Linux distributions include "compiler.h" in their libc linux
1822# headers package, some don't. Most don't need it, building might (!)
1823# not succeed on openSUSE without it.
1824#
1825# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1826#
1827check_compiler_h()
1828{
1829 test_header compiler.h
1830 if ! test -f "/usr/include/linux/compiler.h"; then
1831 log_success "compiler.h not found"
1832 else
1833 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1834 log_success "compiler.h found"
1835 fi
1836}
1837
1838#
1839# Check for libcap.
1840# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1841# sockets for doing ICMP requests.
1842#
1843check_libcap()
1844{
1845 test_header "libcap library"
1846 cat > $ODIR.tmp_src.cc << EOF
1847#include <cstdio>
1848#include <sys/types.h>
1849#include <linux/types.h>
1850#include <sys/capability.h>
1851
1852extern "C" int main(void)
1853{
1854 char buf[1024];
1855 cap_t caps = cap_get_proc();
1856 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1857 return 0;
1858}
1859EOF
1860 if test_compile $LIBCAP libcap libcap; then
1861 if test_execute; then
1862 log_success "found"
1863 fi
1864 fi
1865}
1866
1867#
1868# Check if we are able to build 32-bit applications (needed for the guest additions)
1869#
1870check_32bit()
1871{
1872 test_header "32-bit support"
1873 cat > $ODIR.tmp_src.c << EOF
1874#include <stdint.h>
1875int main(void)
1876{
1877 return 0;
1878}
1879EOF
1880 echo "compiling the following source file:" >> $LOG
1881 cat $ODIR.tmp_src.c >> $LOG
1882 echo "using the following command line:" >> $LOG
1883 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1884 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1885 if [ $? -ne 0 ]; then
1886 echo
1887 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1888 echo " Check the file $LOG for detailed error information."
1889 fail
1890 else
1891 echo "executing the binary" >> $LOG
1892 $ODIR.tmp_out 2> $ODIR.test_execute.log
1893 rc=$?
1894 cat $ODIR.test_execute.log >> $LOG
1895 if [ $rc -ne 0 ]; then
1896 echo
1897 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1898 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1899 fail
1900 return 1
1901 fi
1902 fi
1903 log_success ""
1904}
1905
1906
1907#
1908# Check for Python
1909#
1910check_python()
1911{
1912 test_header "Python support"
1913
1914 # On darwin this is a on/off decision only
1915 if [ "$OS" = "darwin" ]; then
1916 echo "enabled"
1917 cnf_append "VBOX_WITH_PYTHON" "1"
1918 return
1919 fi
1920
1921 cat > $ODIR.tmp_src.cc << EOF
1922#include <cstdio>
1923#include <Python.h>
1924extern "C" int main(void)
1925{
1926 Py_Initialize();
1927 printf("found version %s", PY_VERSION);
1928#if PY_VERSION_HEX >= 0x02030000
1929 printf(", OK.\n");
1930 return 0;
1931#else
1932 printf(", expected version 2.3 or higher\n");
1933 return 1;
1934#endif
1935}
1936EOF
1937 found=
1938# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1939 if [ "$OS" != "solaris" ]; then
1940 SUPPYTHONLIBS="python2.7 python2.6 python2.5 python2.4 python2.3"
1941 else
1942 SUPPYTHONLIBS="python2.4"
1943 fi
1944 for p in $PYTHONDIR; do
1945 for d in $SUPPYTHONLIBS; do
1946 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
1947 echo "compiling the following source file:" >> $LOG
1948 cat $ODIR.tmp_src.cc >> $LOG
1949 echo "using the following command line:" >> $LOG
1950 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1951 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1952 if [ $? -eq 0 ]; then
1953 found=1
1954 break
1955 fi
1956 done
1957 if [ -n "$found" ]; then break; fi
1958 done
1959 if [ -n "$found" ]; then break; fi
1960 done
1961 if [ -n "$found" ]; then
1962 if test_execute; then
1963 cnf_append "VBOX_WITH_PYTHON" "1"
1964 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1965 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1966 else
1967 log_failure "Python not working"
1968 fail
1969 fi
1970 else
1971 log_failure "Python not found"
1972 fail
1973 fi
1974}
1975
1976
1977#
1978# Check for Java
1979#
1980check_java()
1981{
1982 test_header "Java support"
1983 log_success
1984}
1985
1986
1987#
1988# Setup wine
1989#
1990setup_wine()
1991{
1992 test_header "Wine support"
1993 if ! which_wrapper wine > /dev/null; then
1994 echo " wine binary not found"
1995 fail
1996 fi
1997 if ! which_wrapper wine > /dev/null; then
1998 echo " wine not found"
1999 fail
2000 fi
2001 wine_version="`wine --version`"
2002 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2003 "0")
2004 if ! which_wrapper wineprefixcreate > /dev/null; then
2005 echo " wineprefixcreate not found"
2006 fail
2007 fi
2008 ;;
2009 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2010 esac
2011 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2012 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2013 echo "export WINEPREFIX" >> $ENV
2014 rm -rf $WINEPREFIX
2015 mkdir -p $WINEPREFIX
2016 touch $WINEPREFIX/.no_prelaunch_window_flag
2017 if ! wineprefixcreate -q > /dev/null 2>&1; then
2018 echo " wineprefixcreate failed"
2019 fail
2020 fi
2021 tmp=.tmp.wine.reg
2022 rm -f $tmp
2023 echo 'REGEDIT4' > $tmp
2024 echo '' >> $tmp
2025 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2026 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2027 echo '' >> $tmp
2028 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2029 echo '"itss"="native"' >> $tmp
2030 echo '' >> $tmp
2031 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2032 echo '"itss"="native"' >> $tmp
2033 echo '' >> $tmp
2034 if ! wine regedit $tmp > /dev/null 2>&1; then
2035 rm -f $tmp
2036 echo " failed to load registry changes (path)."
2037 fail
2038 fi
2039 rm -f $tmp
2040 log_success "found"
2041}
2042
2043
2044#
2045# Check for gSOAP.
2046#
2047check_gsoap()
2048{
2049 test_header "GSOAP compiler"
2050 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2051 if which_wrapper pkg-config > /dev/null; then
2052 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2053 if [ $? -eq 0 ]; then
2054 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2055 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2056 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2057 GSOAP_IMPORT="$GSOAP/include/gsoap"
2058 fi
2059 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2060 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2061 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2062 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2063 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2064 else
2065 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2066 fi
2067 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2068 gsoap_version=`pkg-config gsoapssl++ --modversion`
2069 log_success "found version $gsoap_version"
2070 return
2071 fi
2072 fi
2073 fi
2074 if [ -z "$GSOAP" ]; then
2075 GSOAP="/usr"
2076 fi
2077 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2078 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2079 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2080 # TODO: Check for libgsoap++.a/so
2081
2082 if [ -z "$GSOAP_IMPORT" ]; then
2083 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2084 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2085 GSOAP_IMPORT="$GSOAP/include/gsoap"
2086 fi
2087 fi
2088 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2089 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2090 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2091 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2092 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2093 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2094 else
2095 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2096 fi
2097 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2098 log_success "found"
2099 else
2100 log_failure "stlvector.h not found -- disabling webservice"
2101 cnf_append "VBOX_WITH_WEBSERVICES" ""
2102 fi
2103 else
2104 log_failure "stdsoap2.h not found -- disabling webservice"
2105 cnf_append "VBOX_WITH_WEBSERVICES" ""
2106 fi
2107 else
2108 log_failure "wsdl2h not found -- disabling webservice"
2109 cnf_append "VBOX_WITH_WEBSERVICES" ""
2110 fi
2111 else
2112 log_failure "soapcpp2 not found -- disabling webservice"
2113 cnf_append "VBOX_WITH_WEBSERVICES" ""
2114 fi
2115}
2116
2117
2118#
2119# Check Xcode path
2120#
2121check_xcode_sdk_path()
2122{
2123 # Check if WITH_XCODE_DIR is set.
2124 if [ -z "$WITH_XCODE_DIR" ]; then
2125 echo "Please specify --with-xcode-dir option."
2126 return 0
2127 fi
2128
2129 # Check if specified path exists and is a directory.
2130 if [ -d "$1" ]; then
2131 return 1
2132 else
2133 echo "Xcode path [$1] not found."
2134 return 0
2135 fi
2136}
2137
2138#
2139# Determines the Darwin version.
2140# @todo This should really check the Xcode/SDK version.
2141#
2142check_darwinversion()
2143{
2144 test_header "Darwin version"
2145 darwin_ver=`uname -r`
2146 case "$darwin_ver" in
2147 14\.*)
2148 check_xcode_sdk_path "$WITH_XCODE_SDK_DIR"
2149 [ $? -eq 1 ] || fail
2150 darwin_ver="10.10" # Yosemite
2151 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2152 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2153 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2154 ;;
2155 13\.*)
2156 check_xcode_sdk_path "$WITH_XCODE_DIR"
2157 [ $? -eq 1 ] || fail
2158 darwin_ver="10.9" # Mavericks
2159 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2160 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2161 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2162 ;;
2163 12\.*)
2164 darwin_ver="10.8" # Mountain Lion
2165 if [ ! -z "$WITH_XCODE_DIR" ]; then
2166 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2167 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2168 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2169 else
2170 sdk=/Developer/SDKs/MacOSX10.6.sdk
2171 fi
2172 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2173 ;;
2174 11\.*)
2175 darwin_ver="10.7" # Lion
2176 sdk=/Developer/SDKs/MacOSX10.6.sdk
2177 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2178 ;;
2179 10\.*)
2180 darwin_ver="10.6" # Snow Leopard
2181 if [ "$BUILD_MACHINE" = "x86" ]; then
2182 sdk=/Developer/SDKs/MacOSX10.5.sdk
2183 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2184 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2185 else
2186 sdk=/Developer/SDKs/MacOSX10.6.sdk
2187 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2188 fi
2189# test "$CC" = "gcc" && CC="gcc-4.0"
2190# test "$CXX" = "g++" && CXX="g++-4.0"
2191 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2192 ;;
2193 9\.*)
2194 darwin_ver="10.5" # Leopard
2195 sdk=/Developer/SDKs/MacOSX10.5.sdk
2196 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2197# test "$CC" = "gcc" && CC="gcc-4.0"
2198# test "$CXX" = "g++" && CXX="g++-4.0"
2199 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2200 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2201 ;;
2202 8\.*)
2203 darwin_ver="10.4" # Tiger
2204 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2205 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2206# test "$CC" = "gcc" && CC="gcc-4.0"
2207# test "$CXX" = "g++" && CXX="g++-4.0"
2208 cnf_append "VBOX_WITH_COCOA_QT" ""
2209 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2210 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2211 ;;
2212 *)
2213 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2214 fail
2215 darwin_ver="unknown"
2216 ;;
2217 esac
2218 log_success "found version $darwin_ver (SDK: $sdk)"
2219}
2220
2221
2222check_makeself()
2223{
2224 test_header "makeself"
2225 if check_avail "$MAKESELF" makeself; then
2226 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2227 if [ $? -ne 0 ]; then
2228 log_failure "makeself not working"
2229 fail
2230 else
2231 log_success "found version $makeself_ver"
2232 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2233 fi
2234 fi
2235}
2236
2237
2238#
2239# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2240# is around to prevent confusion when the build fails in src/recompiler.
2241# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2242#
2243check_i386elfgcc()
2244{
2245 test_header "i386-elf-gcc"
2246 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2247 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2248 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2249 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2250 if test -z "$i386_elf_gcc"; then
2251 echo " failed to find i386-elf-gcc"
2252 fail
2253 fi
2254 log_success "found $i386_elf_gcc"
2255}
2256
2257
2258#
2259# Show help
2260#
2261show_help()
2262{
2263cat << EOF
2264Usage: ./configure [OPTIONS]...
2265
2266Configuration:
2267 -h, --help display this help and exit
2268 --nofatal don't abort on errors
2269EOF
2270[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2271[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2272[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2273[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2274[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2275[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2276[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2277[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2278[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2279[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2280[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2281[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2282[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2283[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2284[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2285[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2286cat << EOF
2287 --disable-udptunnel disable UDP tunnel networking
2288 --disable-devmapper disable device mapper library access
2289 --disable-hardening don't be strict about /dev/vboxdrv access
2290 --build-libxml2 build libxml2 from sources
2291EOF
2292[ $OSE -eq 0 ] && cat << EOF
2293 --build-libssl build openssl from sources
2294 --build-libcurl build libcurl from sources
2295 --build-libvpx build libvpx from sources
2296EOF
2297[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2298cat << EOF
2299 --only-additions only build the Guest Additions
2300
2301Paths:
2302 --with-gcc=PATH location of the gcc compiler [$CC]
2303 --with-g++=PATH location of the g++ compiler [$CXX]
2304 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2305 --with-iasl=PATH location of the iasl compiler [$IASL]
2306 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2307 --with-makeself=PATH location of makeself [$MAKESELF]
2308EOF
2309[ "$OS" = "darwin" ] && echo " --with-xcode-dir=DIR custom path to Xcode root directory; it is assumed that Xcode"
2310[ "$OS" = "darwin" ] && echo " contains OS X 10.6 SDK (required for Mountain Lion and newer hosts"
2311[ "$OS" = "darwin" ] && echo " only, ignored for the rest)"
2312[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2313[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2314[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2315[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2316[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2317cat << EOF
2318 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2319 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2320 --out-path=PATH the folder to which configuration and build output
2321 should go
2322
2323Build type:
2324 -d, --build-debug build with debugging symbols and assertions
2325 --build-profile build with profiling support
2326 --build-headless build headless (without any GUI frontend)
2327EOF
2328 exit 0
2329}
2330
2331
2332#
2333# The body.
2334#
2335
2336# test if we are OSE
2337if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2338 OSE=0
2339 # Set this as a reminder to print a log message once we know the path of the
2340 # log file
2341 NOT_OSE=1
2342fi
2343
2344# Change OS specific defaults; must be before all other stuff
2345if [ "$OS" = "darwin" ]; then
2346 WITH_SDL=0
2347 WITH_SDL_TTF=0
2348 WITH_X11=0
2349 WITH_ALSA=0
2350 WITH_PULSE=0
2351 WITH_DBUS=0
2352 WITH_KMODS=0
2353 BUILD_LIBXML2=1
2354 BUILD_LIBVPX=1
2355 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2356 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2357 WITH_XCODE_DIR=""
2358elif [ "$OS" = "haiku" ]; then
2359 #WITH_SDL=0
2360 WITH_SDL_TTF=0
2361 WITH_X11=0
2362 WITH_ALSA=0
2363 WITH_PULSE=0
2364 WITH_DBUS=0
2365 WITH_KMODS=0
2366 WITH_LIBIDL=0
2367 WITH_XPCOM=0
2368 BUILD_LIBXSLT=1
2369 BUILD_LIBXML2=1
2370 WITH_LIBVPX=0
2371 # it is part of libroot, which is linked by default,
2372 # but the script wants something
2373 LIBPTHREAD="-lroot"
2374 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2375 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2376elif [ "$OS" = "solaris" ]; then
2377 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2378fi
2379
2380# scan command line options
2381for option in "$@"; do
2382 case "$option" in
2383 --help|-help|-h)
2384 show_help
2385 ;;
2386 --nofatal)
2387 nofatal=1
2388 ;;
2389 --env-only)
2390 ENV_ONLY=1
2391 ;;
2392 --with-gcc=*)
2393 CC=`echo $option | cut -d'=' -f2`
2394 ;;
2395 --with-g++=*)
2396 CXX=`echo $option | cut -d'=' -f2`
2397 ;;
2398 --with-kbuild=*)
2399 KBUILDDIR=`echo $option | cut -d'=' -f2`
2400 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2401 echo "Error: KBUILDDIR contains invalid characters!"
2402 exit 1
2403 fi
2404 ;;
2405 --with-qt-dir=*|--with-qt4-dir=*)
2406 QT4DIR=`echo $option | cut -d'=' -f2`
2407 QT4DIR_PKGCONFIG=0
2408 ;;
2409 --with-openssl-dir=*)
2410 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2411 INCCRYPTO="-I${OPENSSLDIR}/include"
2412 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2413 ;;
2414 --with-ow-dir=*)
2415 WATCOM=`echo $option | cut -d'=' -f2`
2416 ;;
2417 --with-gsoap-dir=*)
2418 GSOAP=`echo $option | cut -d'=' -f2`
2419 ;;
2420 --with-gsoap-import=*)
2421 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2422 ;;
2423 --with-iasl=*)
2424 IASL=`echo $option | cut -d'=' -f2`
2425 ;;
2426 --with-xcode-dir=*)
2427 WITH_XCODE_DIR=`echo $option | cut -d'=' -f2`
2428 echo $option
2429 ;;
2430 --with-linux=*)
2431 LINUX=`echo $option | cut -d'=' -f2`
2432 ;;
2433 --with-mkisofs=*)
2434 MKISOFS=`echo $option | cut -d'=' -f2`
2435 ;;
2436 --with-makeself=*)
2437 MAKESELF=`echo $option | cut -d'=' -f2`
2438 ;;
2439 --target-arch=*)
2440 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2441 ;;
2442 --disable-xpcom)
2443 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2444 ;;
2445 --disable-python)
2446 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2447 ;;
2448 --disable-java)
2449 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2450 ;;
2451 --disable-vmmraw)
2452 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2453 ;;
2454 --disable-sdl-ttf)
2455 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2456 ;;
2457 --disable-qt)
2458 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2459 ;;
2460 --disable-qt4)
2461 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2462 ;;
2463 --passive-mesa)
2464 PASSIVE_MESA=1
2465 ;;
2466 --disable-alsa)
2467 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2468 ;;
2469 --disable-pulse)
2470 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2471 ;;
2472 --enable-pulse)
2473 WITH_PULSE=2
2474 ;;
2475 --disable-dbus)
2476 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2477 ;;
2478 --disable-kmods)
2479 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2480 ;;
2481 --disable-opengl)
2482 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2483 ;;
2484 --enable-webservice)
2485 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2486 ;;
2487 --enable-vnc)
2488 WITH_VNC=1
2489 ;;
2490 --disable-hardening)
2491 WITH_HARDENING=0
2492 ;;
2493 --disable-extpack)
2494 WITH_EXTPACK=0
2495 ;;
2496 --disable-docs)
2497 WITH_DOCS=0
2498 ;;
2499 --enable-hardening)
2500 WITH_HARDENING=2
2501 ;;
2502 --disable-udptunnel)
2503 WITH_UDPTUNNEL=0
2504 ;;
2505 --enable-vde)
2506 WITH_VDE=1
2507 ;;
2508 --disable-devmapper)
2509 WITH_DEVMAPPER=0
2510 ;;
2511 --disable-libvpx)
2512 WITH_LIBVPX=0
2513 ;;
2514 --disable-vboxsdl)
2515 WITH_SDL=0
2516 ;;
2517 --build-debug|-d)
2518 BUILD_TYPE=debug
2519 ;;
2520 --build-profile)
2521 BUILD_TYPE=profile
2522 ;;
2523 --build-libxml2)
2524 BUILD_LIBXML2=1
2525 ;;
2526 --build-libssl)
2527 BUILD_LIBSSL=1
2528 ;;
2529 --build-libcurl)
2530 BUILD_LIBCURL=1
2531 ;;
2532 --build-libvpx)
2533 BUILD_LIBVPX=1
2534 ;;
2535 --build-headless)
2536 HEADLESS=1
2537 WITH_SDL=0
2538 WITH_SDL_TTF=0
2539 WITH_X11=0
2540 WITH_OPENGL=0
2541 WITH_QT4=0
2542 ;;
2543 --ose)
2544 OSE=2
2545 ;;
2546 --odir=*)
2547 ODIR="`echo $option | cut -d'=' -f2`/"
2548 ODIR_OVERRIDE=1
2549 ;;
2550 --out-path=*)
2551 out_path="`echo $option | cut -d'=' -f2`/"
2552 if [ -d $out_path ]; then
2553 saved_path="`pwd`"
2554 cd $out_path
2555 OUT_PATH="`pwd`"
2556 cd $saved_path
2557 OUT_PATH_OVERRIDE=1
2558 if [ $ODIR_OVERRIDE -eq 0 ]; then
2559 # This variable has not *yet* been overridden. That can still happen.
2560 ODIR=$OUT_PATH/
2561 fi
2562 else
2563 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2564 exit 1
2565 fi
2566 ;;
2567 --setup-wine)
2568 [ "$OS" != "darwin" ] && SETUP_WINE=1
2569 ;;
2570 --only-additions)
2571 ONLY_ADDITIONS=1
2572 ;;
2573 *)
2574 echo
2575 echo "Unrecognized option \"$option\""
2576 echo
2577 show_help
2578 ;;
2579 esac
2580done
2581
2582LOG="$ODIR$LOG"
2583ENV="$ODIR$ENV"
2584CNF="$ODIR$CNF"
2585
2586# initialize output files
2587cat > $LOG << EOF
2588# Log file generated by
2589#
2590# '$0 $*'
2591#
2592
2593EOF
2594cat > $CNF << EOF
2595# -*- Makefile -*-
2596#
2597# automatically generated by
2598#
2599# '$0 $*'
2600#
2601# It will be completely overwritten if configure is executed again.
2602#
2603
2604EOF
2605cat > $ENV << EOF
2606#!/bin/bash
2607#
2608# automatically generated by
2609#
2610# '$0 $*'
2611#
2612# It will be completely overwritten if configure is executed again.
2613# Make sure you source this file once before you start to build VBox.
2614#
2615
2616EOF
2617
2618# Print log warning about OSE if necessary
2619if [ -n "$NOT_OSE" ]; then
2620 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2621 echo >> $LOG
2622fi
2623
2624
2625if [ "$BUILD_TYPE" = "debug" ]; then
2626 echo "Creating DEBUG build!" >> $LOG
2627elif [ "$BUILD_TYPE" = "profile" ]; then
2628 echo "Creating PROFILE build!" >> $LOG
2629fi
2630
2631# first determine our environment
2632check_environment
2633check_kbuild
2634
2635[ -n "$ENV_ONLY" ] && exit 0
2636
2637# append the tools directory to the default search path
2638echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2639export PATH
2640
2641# if we will be writing to a different out directory then set this up now
2642if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2643 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2644 echo "export AUTOCFG" >> $ENV
2645 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2646 echo "export LOCALCFG" >> $ENV
2647 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2648 echo "export PATH_OUT_BASE" >> $ENV
2649fi
2650
2651# some things are not available in for OSE
2652if [ $OSE -ge 1 ]; then
2653 cnf_append "VBOX_OSE" "1"
2654 cnf_append "VBOX_WITH_VALIDATIONKIT" ""
2655 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2656
2657 if [ "$OS" = "linux" ]; then
2658 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2659 else
2660 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2661 fi
2662 echo >> $CNF
2663fi
2664
2665# extpack
2666if [ $ONLY_ADDITIONS -eq 1 ]; then
2667 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2668elif [ $OSE -eq 0 ]; then
2669 if [ $WITH_EXTPACK -eq 1 ]; then
2670 BUILD_LIBSSL=1
2671 else
2672 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2673 fi
2674fi
2675
2676# headless
2677if [ -n "$HEADLESS" ]; then
2678 cnf_append "VBOX_HEADLESS" "1"
2679fi
2680
2681# emit disable directives corresponding to any --disable-xxx options.
2682if [ $WITH_OPENGL -eq 0 ]; then
2683 cnf_append "VBOX_WITH_CROGL" ""
2684 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2685 cnf_append "VBOX_GUI_USE_QGL" ""
2686fi
2687[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2688[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2689[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2690[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2691[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2692[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2693[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2694[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2695[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2696[ $WITH_LIBVPX -eq 0 ] && cnf_append "VBOX_WITH_VPX" ""
2697
2698# Darwin-specific
2699if [ "$OS" = "darwin" ]; then
2700 check_darwinversion
2701fi
2702# the tools
2703check_gcc
2704if [ $ONLY_ADDITIONS -eq 0 ]; then
2705 check_open_watcom
2706 [ "$OS" != "darwin" ] && check_iasl
2707 # don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2708 # [ "$OS" != "darwin" ] && check_yasm
2709 [ "$OS" != "darwin" ] && check_xsltproc
2710 [ "$OS" != "darwin" ] && check_mkisofs
2711fi
2712
2713# the libraries
2714if [ $ONLY_ADDITIONS -eq 0 ]; then
2715 [ "$OS" != "darwin" ] && check_pthread
2716 check_libxml2
2717 [ $WITH_LIBIDL -eq 1 ] && check_libidl
2718 check_ssl
2719 check_curl
2720 [ $WITH_LIBVPX -eq 1 ] && check_vpx
2721 [ "$OS" != "darwin" ] && check_z
2722 [ "$OS" != "darwin" ] && check_png
2723 [ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2724 if [ $WITH_SDL -eq 1 ]; then
2725 check_sdl
2726 else
2727 cnf_append "VBOX_WITH_VBOXSDL" ""
2728 fi
2729 [ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2730 [ $WITH_X11 -eq 1 ] && check_x
2731 # TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2732 # TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2733 [ $WITH_X11 -eq 1 ] && check_xcursor
2734 [ $WITH_X11 -eq 1 ] && check_xinerama
2735 [ $WITH_X11 -eq 1 ] && check_xrandr
2736 [ $WITH_OPENGL -eq 1 ] && check_opengl
2737 [ $WITH_QT4 -eq 1 ] && check_qt4
2738 [ $WITH_PYTHON -eq 1 ] && check_python
2739 [ $WITH_JAVA -eq 1 ] && check_java
2740
2741 # PulseAudio
2742 if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2743 if [ $WITH_PULSE -eq 1 ]; then
2744 check_pulse
2745 elif [ $WITH_PULSE -eq 0 ]; then
2746 cnf_append "VBOX_WITH_PULSE" ""
2747 fi
2748 fi
2749fi
2750
2751# Linux-specific
2752if [ "$OS" = "linux" ]; then
2753 # don't check for the static libstdc++ in the PUEL version as we build the
2754 # additions at a dedicated box
2755 [ $OSE -ge 1 ] && check_staticlibstdcxx
2756 if [ $WITH_KMODS -eq 1 ]; then
2757 check_linux
2758 else
2759 cnf_append "VBOX_LINUX_SRC" ""
2760 cnf_append "VBOX_WITH_VBOXDRV" ""
2761 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2762 fi
2763 if [ $ONLY_ADDITIONS -eq 0 ]; then
2764 if [ $WITH_ALSA -eq 1 ]; then
2765 check_alsa
2766 else
2767 cnf_append "VBOX_WITH_ALSA" ""
2768 fi
2769 if [ $WITH_DBUS -eq 0 ]; then
2770 cnf_append "VBOX_WITH_DBUS" ""
2771 fi
2772 if [ $WITH_DEVMAPPER -eq 1 ]; then
2773 check_libdevmapper
2774 else
2775 cnf_append "VBOX_WITH_DEVMAPPER" ""
2776 fi
2777 check_libcap
2778 fi
2779 check_compiler_h
2780 [ $ONLY_ADDITIONS -eq 0 -a "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2781 # tools/common/makeself*
2782 [ $OSE -ge 1 ] && check_makeself
2783fi
2784
2785[ -n "$SETUP_WINE" ] && setup_wine
2786
2787if [ $ONLY_ADDITIONS -eq 0 -a $WITH_GSOAP -eq 1 ]; then
2788 check_gsoap
2789else
2790 if [ $OSE -ge 1 ]; then
2791 cnf_append "VBOX_WITH_WEBSERVICES" ""
2792 fi
2793fi
2794
2795# UDPTUNNEL
2796if [ $ONLY_ADDITIONS -eq 0 -a $WITH_UDPTUNNEL -eq 0 ]; then
2797 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2798fi
2799
2800# VDE
2801if [ $ONLY_ADDITIONS -eq 0 -a "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2802 if [ $WITH_VDE -eq 1 ]; then
2803 cnf_append "VBOX_WITH_VDE" "1"
2804 fi
2805fi
2806
2807# DOCS
2808if [ $ONLY_ADDITIONS -eq 1 -o $WITH_DOCS -eq 0 ]; then
2809 cnf_append "VBOX_WITH_DOCS" ""
2810 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2811fi
2812
2813# VNC server support
2814if [ $ONLY_ADDITIONS -eq 0 -a $OSE -ge 1 ]; then
2815 if [ $WITH_VNC = 1 ]; then
2816 check_vncserver
2817 else
2818 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2819 fi
2820fi
2821
2822if [ $ONLY_ADDITIONS -eq 1 ]; then
2823 cnf_append "VBOX_ONLY_ADDITIONS" "1"
2824fi
2825
2826# success!
2827echo
2828echo "Successfully generated '$CNF' and '$ENV'."
2829echo "Source '$ENV' once before you start to build VBox:"
2830echo ""
2831echo " source $ENV"
2832echo " kmk"
2833echo ""
2834if [ "$OS" = "linux" ]; then
2835 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2836 vbox_out_path=$OUT_PATH
2837 else
2838 vbox_out_path=./out
2839 fi
2840 echo "To compile the kernel modules, do:"
2841 echo ""
2842 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2843 echo " make"
2844 echo ""
2845fi
2846if [ $ONLY_ADDITIONS -eq 1 ]; then
2847 echo ""
2848 echo " Tree configured to build only the Guest Additions"
2849 echo ""
2850elif [ $WITH_HARDENING -gt 0 ]; then
2851 echo ""
2852 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2853 echo " Hardening is enabled which means that the VBox binaries will not run from"
2854 echo " the binary directory. The binaries have to be installed suid root and some"
2855 echo " more prerequisites have to be fulfilled which is normally done by installing"
2856 echo " the final package. For development, the hardening feature can be disabled"
2857 echo " by specifying the --disable-hardening parameter. Please never disable that"
2858 echo " feature for the final distribution!"
2859 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2860 echo ""
2861else
2862 echo ""
2863 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2864 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2865 echo " disabled hardening!"
2866 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2867 echo ""
2868fi
2869echo "Enjoy!"
2870cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette